/* border_value.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __BORDER_VALUE_H__
#define __BORDER_VALUE_H__

#include "deriche.h"
#include "tab_dart_value.h"
#include "tab_dart.h"
#include "image.h"
#include "classe.h"
#include <assert.h>

CLASSE(border_value);

#include "pyramid.h"


extern border_value new_border_value(image);
extern void destroy_border_value(border_value);

extern void border_value_put_alpha_deriche_value(double);
extern float border_value_give_value(border_value,int);
extern int border_value_give_cardinal(border_value,int);
extern float border_value_give_mean(border_value,int);
extern float border_value_give_max(border_value);

extern void  border_value_put_value(border_value,int,float);
/* self, ind, val */
extern void  border_value_put_cardinal(border_value,int,int);
/* self, ind, card */

extern float init_edge(any_ptr,pyramid,vertex);
extern void merge_border(any_ptr,pyramid,int,dart,dart);
#endif /* __BORDER_VALUE_H__ */
