/* coul_freq.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef COUL_FREQ_H
#define COUL_FREQ_H

#include "image.h"
#include "types.h"

#include "objet.h"
#include "classe.h"

CLASSE(coul_freq);

extern coul_freq FAIRE_coul_freq(image,int);
extern void      DEFAIRE_coul_freq(coul_freq);

extern double coul_freq_projection(coul_freq,int,int,intervalle*,double*,double*);

extern int coul_freq_give_min_C1(coul_freq);
extern int coul_freq_give_max_C1(coul_freq);
extern int coul_freq_give_min_C2(coul_freq);
extern int coul_freq_give_max_C2(coul_freq);
extern int coul_freq_give_min_C3(coul_freq);
extern int coul_freq_give_max_C3(coul_freq);

extern int* coul_freq_give_median(coul_freq,int*,int*);

#endif
