/* level_set.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __LEVEL_SET_H__
#define __LEVEL_SET_H__

#include "classe.h"
#include "type_obj.h"
#include "tab_int.h"
#include "image.h"

CLASSE(level_set);

extern level_set new_level_set(int);
extern level_set level_set_load(image,tab_int);
extern void      destroy_level_set(level_set);


extern void    level_set_new_level(level_set);
extern void    level_set_suppress_edge(level_set,dart);
extern int     level_set_give_max_level(level_set);
extern void    level_set_first(level_set,int);
extern dart    level_set_current(level_set);
extern bouleen level_set_next(level_set);
extern tab_int level_set_give_all_levels(level_set);
#endif
