/* pyramid.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __PYRAMID_H__
#define __PYRAMID_H__

#include <stdio.h>
#include "classe.h"
#include "type_obj.h"


CLASSE(pyramid);

typedef enum {pyr_draw_all,pyr_draw_both,pyr_draw_single} draw_mode;

#include "pyramid_user_functions.h"
#include "pyramid_access_functions.h"
#include "pyramid_io_functions.h"
#include "pyramid_drawing.h"




extern pyramid new_pyramid(int,int,vertex_data*,dart_data*);
extern void    destroy_pyramid(pyramid,PFfree);



extern void pyramid_init_node_value(pyramid,PFinit_node_value);
extern void pyramid_init_edge_value(pyramid,PFinit_edge_value);
extern move_type give_move(pyramid,dart);

extern void pyramid_sequential_reduce(pyramid,sequential_seg *);
extern void pyramid_parallel_reduce(pyramid, parallel_seg *par_seg);

extern void pyramid_debug(pyramid);
#endif
