/* pyramid_value.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __PYRAMID_VALUE_H__
#define __PYRAMID_VALUE_H__

#include "type_obj.h"
#include "tab_gen.h"
#include "image.h"
#include "classe.h"
#include "quantize.h"

CLASSE(vertex_value);
CLASSE(pyramid_value);

#include "pyramid.h"


extern vertex_value new_vertex_value(int *,quantize ,int );
extern any_ptr 	    init_node(any_ptr,pyramid,vertex);
extern void 	    vertex_value_reset(vertex_value,double*,double*,int,int,int,int);
extern void 	    vertex_value_give_color(vertex_value,double*);
extern void 	    vertex_value_give_squared_color(vertex_value,double*);
extern int 	    vertex_value_give_cardinal(vertex_value);
extern void 	    vertex_value_give_mean(vertex_value,double*);
extern double 	    vertex_value_give_variance(vertex_value);
extern double 	    vertex_value_give_se(vertex_value);
extern int 	    vertex_value_give_label(vertex_value);
extern int 	    vertex_value_give_perimetre(vertex_value);
extern void 	    vertex_value_add_perimetre(vertex_value,int);

extern pyramid_value new_pyramid_value(image,quantize);
extern void 	     destroy_pyramid_value(pyramid_value);
extern void 	     pyramid_value_release_after_init(pyramid_value);
extern any_ptr 	     pyramid_value_give_vertex_value(pyramid_value,vertex);
extern void 	     pyramid_value_remove_object(pyramid_value,vertex);
extern void 	     init_pyramid_value(image,quantize);
extern void 	    
pyramid_value_reset(pyramid_value,vertex,double*,double*,int,int,int);
extern void 	     pyramid_value_give_color(pyramid_value,vertex,double*);
extern int 	     pyramid_value_give_cardinal(pyramid_value,vertex);
extern void 	     pyramid_value_give_mean(pyramid_value,vertex,double*);
extern double 	     pyramid_value_give_variance(pyramid_value,vertex);
extern double 	     pyramid_value_give_se(pyramid_value,vertex);
extern int 	     pyramid_value_give_label(pyramid_value,vertex);
extern int 	     pyramid_value_give_perimetre(pyramid_value,vertex);
extern void 	     pyramid_value_add_perimetre(pyramid_value,vertex,int);
extern int 	     pyramid_value_give_dim_img(pyramid_value);

extern any_ptr merge_value(any_ptr,pyramid,int,vertex,vertex);

extern void    value_remove_noise();


#endif /* __PYRAMID_VALUE_H__ */
