/* quantize.c (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include"quantize.h"

#define Arbre    SELF(arbre)
#define Espace   SELF(espace)


struct quantize
{
  arbre_binaire arbre;
  int espace;
};

extern quantize do_quantize(int K,image img,int espace)
{
  coul_freq c_freq;
  static float ecart_max=30.0;

  INSTANCIER(quantize);

  Espace=espace;
  c_freq = FAIRE_coul_freq(img,Espace);
  Arbre  = FAIRE_arbre_binaire(c_freq,
                               1,
                               0,
                               0,
                               0);

  arbre_binaire_creer_la_table(Arbre,c_freq,&K,ecart_max);
  arbre_binaire_etiqueter_feuilles(Arbre,NULL);
  return self;
}

extern void destroy_quantize(quantize self)
{
  DEFAIRE_arbre_binaire(Arbre);
  free(self);
}

extern int  quantize_give_color_index(quantize self,int* color)
{
  int indice;
  int C[3];
  int i;
  PFconversion *rgb_to_c1c2c3 =changer_espace(Espace);
  for(i=0;i<3;i++)
  	C[i] = rgb_to_c1c2c3[i](color[0],color[1],color[2]);
  arbre_binaire_chercher_couleur_ds_table(Arbre,C,&indice);

  return indice;
}
